#!/usr/bin/python
# -*- coding: utf-8 -*-
'''
 *  Copyright (C) 2007 Karlheinz Klingbeil (lunqual)
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MeRCHANTABILITY or FITNeSS FOR A PARTICULAR PURPOSe.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 
 '''
import getopt
import kontraktion
import sys

VERSION='K 0.2/01.10.2007'

#--------------------------------------------
#
# Hier wird die Kommandozeile in einzelne
# Befehle (getrennt durch Leerzeichen)
# zerlegt und diese wiederum in ihre
# Bestandteile (getrennt durch Doppelpunkte)
# 
# Zurückgegeben wird eine Liste von Listen
#
#--------------------------------------------

def parseCommandLine():
    zutaten = []
    for arg in sys.argv[1:]:
        if ':' in arg:
            liste=arg.split(':')
            zutaten.append(liste)
    return zutaten

#-----------------------------------------
# Name, Liter,´Trockensubstanz
# und Litergewicht aus einer
# Zutat extrahieren
#-----------------------------------------

def get(was,zutat):
    for teil in zutat:
        if teil.lower().startswith(was):
            try:
                return float(teil.split('=')[1].replace(',','.'))
            except:
                return 0.0
    return 0.0

#-----------------------------------------
#
# Die liste der Zutaten wird in die
# Kontraktionsliste übertragen
#
#------------------------------------------
def makeList(list,zutaten):
    for zutat in zutaten:
        liste.add(kontraktion.Zutat(Name=zutat[0],Liter=get('l=',zutat),Staerke=get('s=',zutat),Trockensubstanz=get('t=',zutat),Litergewicht=get('g=',zutat)))
        
if __name__ == '__main__':
    Ziel = 0.0
    print 'Kontraktionsrechner %s\n' %(VERSION)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "z:", ["ziel="])
    except getopt.GetoptError:
        sys.exit(2)
    for o, a in opts:
        if o in ("-z","--ziel"):
            try:
                Ziel = float(a.replace(',','.'))
            except:
                Ziel = 0.0

    liste = kontraktion.ZutatenListe()
    makeList(liste,parseCommandLine())
    # Kontraktion berechnen
    if abs(Ziel) < 0.001:
        liste.rechnen()
    else:
        liste.einstellen(Ziel)
    # Standard-Textausgabe
    print liste.toString()